/* 
	FILE: Tool.cpp
	PURPOSE: Basic math and conversions utility source file (Implementation)
	Author: Carlos Jimnez de Parga (c)
	License: GPL v3.0
*/


#include "tool.h"


// ----------------------------------------------------------------------------
// Tool namespace implementation
// ----------------------------------------------------------------------------

// Returns OpenGL scene coordinates given client's mouse coorindates

Tool::Vector3D Tool::Math::GetOGLPos(const int x, const int y,const int ScreenWidth,const int ScreenHeight)
{
	
	const int WindowY = (ScreenHeight - y) - ScreenHeight/2.0f; 
	const float NormY = float(WindowY)/float(ScreenHeight/2.0f); 
	const int WindowX = x - ScreenWidth/2.0f; 
	const float NormX =  float(WindowX)/float(ScreenWidth/2.0f);

	float vy = 28.0f * NormY; // Scale factor
	float vx = 28.0f * NormX;
	
	return Vector3D(vx, vy, 0.0f);
}


// Class to receive the picked OpenGL objects in the scene

Tool::Idents::Idents(const int hits)
{
	m_Hits = hits;
}

// Set up candidates

void Tool::Idents::SetIdents(const GLuint *Idents)
{
	memcpy(m_Idents,Idents,sizeof(GLuint)*64);
}

// Get candidate

GLuint Tool::Idents::GetItem(const int i)
{
	return m_Idents[i * 4 + 3];
}

// Get hits

int Tool::Idents::GetHits()
{
	return m_Hits;
}