/*****************************************************************************
   ISSIGraph: Experimental Surface Editor Prototype						 
   Copyright (C) 2013 by Carlos Jimnez de Parga								 
   
   Trabajo para el:
   MASTER EN INVESTIGACIN EN INGENIERA DE SOFTWARE Y SISTEMAS INFORMTICOS
			REPRESENTACIN GRFICA DE SUPERFICIES IMPLCITAS			
	DEPARTAMENTO DE INGENIERA DE SOFTWARE Y SISTEMAS INFORMTICOS 
							- UNED -

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.
   **************************************************************************/

/* 
	FILE: Tool.h
	PURPOSE: Basic math and conversions utility source file (Header)
	Author: Carlos Jimnez de Parga (c)
	License: GPL v3.0
*/



#ifndef _TOOL_H
#define _TOOL_H

#define GLEW_STATIC

#include "gl/glew.h"
#include "wx/wx.h"
#include "wx/glCanvas.h"

namespace Tool
{
	
	class Idents // List of Opengl idents
	{
	public:
		Idents(const int hits);
		GLuint GetItem(const int i);
		void SetIdents(const GLuint *idents);
		int GetHits();
	private:
		GLuint m_Idents[64]; // Candidate's array
		int m_Hits;
	};
	
	// General pourpose coordinate structure
	
	class COORDS
	{
	public:	
		float m_x;
		float m_y;
	public:
		COORDS()
		{
		}

		COORDS(float x, float y)
		{
			m_x = x;
			m_y = y;
		}
	};

	class Vector3D // 3D Vector
	{
	public:
    
		Vector3D() 
		{
			m_x = 0.0f;
			m_y = 0.0f;
			m_z = 0.0f;
		}

		Vector3D(const float x, const float y, const float z) 
		{ 
			m_x = x;
			m_y = y; 
			m_z = z;
		}

		// Overload the + operator to  add vectors together 
		Vector3D operator+(const Vector3D Vector)
		{
			// Return the added vectors result.
			return Vector3D(Vector.m_x + m_x, Vector.m_y + m_y, Vector.m_z + m_z);
		}

		// Overload the - operator to subtract vectors 
		Vector3D operator-(const Vector3D Vector)
		{
			// Return the subtracted vectors result
			return Vector3D(m_x - Vector.m_x, m_y - Vector.m_y, m_z - Vector.m_z);
		}
    
		// Overload the * operator to multiply by scalars
		Vector3D operator*(const float Num)
		{
			// Return the scaled vector
			return Vector3D(m_x * Num, m_y * Num, m_z * Num);
		}

		// Overload the / operator to divide by a scalar
		Vector3D operator/(const float Num)
		{
			// Return the scale vector
			return Vector3D(m_x / Num, m_y / Num, m_z / Num);
		}

		float m_x, m_y, m_z;                       
	};


	class Math // Math and wxString conversion operations
	{
	public:
		static Vector3D GetOGLPos(const int x,const  int y,const int ScreenWidth,const int ScreenHeight);
		template <typename T> static wxString ConvertNumber(const T Number)
		{
			wxString Str;
			Str << Number;
			return Str;
		}
	};
};


#endif